package hornetq.test.client;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import org.hornetq.api.core.SimpleString;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.client.ClientConsumer;
import org.hornetq.api.core.client.ClientMessage;
import org.hornetq.api.core.client.ClientProducer;
import org.hornetq.api.core.client.ClientSession;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.ServerLocator;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;

public class Client {
	public static void main(String... args) throws Exception 
	{
		ServerLocator serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(NettyConnectorFactory.class.getName()));
		
		ClientSessionFactory sessionFactory = serverLocator.createSessionFactory();
		
		ClientSession session = sessionFactory.createSession();
		
		String queueName = "test.php.queue";
		String address = "test.php";
		if (!session.queueQuery(new SimpleString(queueName)).isExists())
				session.createQueue(address, queueName, false);
		
		ClientConsumer consumer = session.createConsumer(queueName);
		ClientProducer producer = session.createProducer(address);
		session.start();
		
		
		try {
			ClientMessage message;
			
			/*
			message = session.createMessage(false);
			message.getBodyBuffer().writeString("{\"param1\" = \"value1\"}");
			producer.send(message);
			*/
			
			message = consumer.receive();
		
			// message.getBodyBuffer().readString(); // uncomment this to get exception
			
			byte[] body = new byte[message.getBodySize()];
			message.getBodyBuffer().readBytes(body);
			
			System.out.println("Message received: body = " + Arrays.toString(body));
			
			
		} catch (Throwable ex ) { 
			ex.printStackTrace();
		}
		
	}
}
